import os
import pandas as pd
import sys
import matplotlib.pyplot as plt

#Global flag to only count Basic once
flag=True 


#Analysis of one file, returns the results for auto and SMT
def read_file(filename,tactic,nb_provers):
    global flag
    basic_counted=False
    file = open(filename,'r')
    lines=file.readlines()
    res={
        "SMT"+" false" : 0,
        "SMT"+" true" : 0,
        "SMT"+" fail" : 0,
        
        tactic+" false" : 0,
        tactic+" true" : 0,
        tactic+" fail" : 0,
        
        "SMT"+" true "+tactic+" false" : 0,
        "SMT"+" false "+tactic+" true" : 0 
    } 
    for i in range(0,len(lines)-1,nb_provers+1):
        line1=lines[i]
        line2=[lines[i+k].split(":;")[4] for k in range(1,nb_provers+1)]
        splitted_line1=line1.split(":;")
        if "true" in line2:
            res_all="true"
        elif "fail" in line2:
            res_all="fail"
        else:
            res_all="false"
        if flag or ("Basic" not in splitted_line1[1]):
            if "Basic" in splitted_line1[1] : basic_counted = True
            res[splitted_line1[2] + " " + splitted_line1[4]]+=1
            res["SMT" + " " + res_all]+=1
            if res_all!=splitted_line1[4] and res_all!="fail":
                res["SMT"+" "+res_all+" "+tactic+" "+splitted_line1[4]]+=1
    flag= flag and not(basic_counted)
    return res

def main():
    tactic_name="auto"
    nb_provers=int(sys.argv[2])
    tactic="TraceTactics"
    listfiles=os.listdir()
    res={
        "SMT"+" false" : 0,
        "SMT"+" true" : 0,
        "SMT"+" fail" : 0,
        
        tactic+" false" : 0,
        tactic+" true" : 0,
        tactic+" fail" : 0,
        
        "SMT"+" true "+tactic+" false" : 0,
        "SMT"+" false "+tactic+" true" : 0 
    }
    for filename in listfiles:
        #We only read files containing results for our benchmark.
        if tactic_name+"_" in filename : 
            file_res=read_file(filename,tactic,nb_provers)
            res["SMT"+" false"]+=file_res["SMT"+" false"]
            res["SMT"+" true"]+=file_res["SMT"+" true"]
            res["SMT"+" fail"]+=file_res["SMT"+" fail"]
            res[tactic+" false"]+=file_res[tactic+" false"]
            res[tactic+" true"]+=file_res[tactic+" true"]
            res[tactic+" fail"]+=file_res[tactic+" fail"]
            res["SMT"+" true "+tactic+" false"]+=file_res["SMT"+" true "+tactic+" false"]
            res["SMT"+" false "+tactic+" true"]+=file_res["SMT"+" false "+tactic+" true"]
    table = [[res["SMT"+" true"],res["SMT"+" false"],res["SMT"+" fail"]],[res[tactic+" true"],res[tactic+" false"],res[tactic+" fail"]]]
    df=pd.DataFrame(table,columns=["true","false","fail"],index=["SMT","tac"])
    print(df)
    print(f'{res["SMT"+" true "+tactic+" false"]} cases where SMT proves the goal but not auto\n{res["SMT"+" false "+tactic+" true"]} where auto proves the goal but not SMT')
 
if __name__=="__main__":

    os.chdir(sys.argv[1])
    main()



