import os
import pandas as pd
import sys
import matplotlib.pyplot as plt

#Global flag to only count Basic once
flag=True

def fail_false(s):
    if s=="fail":
        return "false"
    return s

#Analysis of one file, returns the results for auto and SMT
def read_file(filename,tactic,prover):
    global flag
    basic_counted=False
    file = open(filename,'r')
    diff_res = open("different_res.txt","a")
    smt_false = open("smt_false.txt","a")
    smtfails = open("smt_fails.txt","a")
    lines=file.readlines()

    res={
        "SMT_"+prover+" false" : 0,
        "SMT_"+prover+" true" : 0,
        "SMT_"+prover+" fail" : 0,
        
        tactic+" false" : 0,
        tactic+" true" : 0,
        tactic+" fail" : 0,
        
        "SMT_"+prover+" true "+tactic+" false" : 0,
        "SMT_"+prover+" false "+tactic+" true" : 0 
    }
    temps_SMT=[]
    temps_auto=[]
    temps_true_SMT=[]
    temps_true_auto=[]
    temps_false_SMT=[]
    temps_false_auto=[]
    for i in range(0,len(lines)-1,3):
        line1=lines[i+2]
        line2=lines[i+1]
        splitted_line1=line1.split(":;")
        splitted_line2=line2.split(":;")
        if flag or ("Basic" not in splitted_line1[1]):
            if "Basic" in splitted_line1[1] : basic_counted = True
            res[splitted_line1[2] + " " + fail_false(splitted_line1[4])]+=1
            res[splitted_line2[2] + " " + splitted_line2[4]]+=1
            if splitted_line2[4]!='fail':
                temps_SMT.append([float(splitted_line2[5]),splitted_line2[4]])
                temps_auto.append([float(splitted_line1[5]),splitted_line1[4]])
                if fail_false(splitted_line1[4])!=splitted_line2[4]:
                    diff_res.write(line1)
                    diff_res.write(line2)
                    diff_res.write("\n")
            if fail_false(splitted_line1[4])!=splitted_line2[4]:
                if splitted_line2[4]!='fail':
                    res["SMT_"+prover+" " + splitted_line2[4] + " "+tactic+" "+fail_false(splitted_line1[4])]+=1
                else :
                    smtfails.write(line1)
                    smtfails.write(line2)
                    smtfails.write("\n")
                if splitted_line2[4]=="false":
                    smt_false.write(line1)
                    smt_false.write(line2)
                    smt_false.write("\n")
            if fail_false(splitted_line2[4])=="true":
                temps_true_SMT.append(float(splitted_line2[5]))
            if fail_false(splitted_line1[4])=="true":
                temps_true_auto.append(float(splitted_line1[5]))
            if fail_false(splitted_line2[4])=="false":
                temps_false_SMT.append(float(splitted_line2[5]))
            if fail_false(splitted_line1[4])=="false":
                temps_false_auto.append(float(splitted_line1[5]))

                
    flag=flag and not(basic_counted)
    file.close()
    diff_res.close()
    smt_false.close()
    return res,temps_true_auto,temps_true_SMT,temps_false_auto,temps_false_SMT,temps_auto,temps_SMT

def main():
    prover=sys.argv[2]
    tactic_name="autosimpl"
    tactic="AutoSimpl"
    listfiles=os.listdir()
    res={
        "SMT_"+prover+" false" : 0,
        "SMT_"+prover+" true" : 0,
        "SMT_"+prover+" fail" : 0,
        
        tactic+" false" : 0,
        tactic+" true" : 0,
        tactic+" fail" : 0,
        
        "SMT_"+prover+" true "+tactic+" false" : 0,
        "SMT_"+prover+" false "+tactic+" true" : 0 
    }
    temps_all_smt=[]
    temps_all_auto=[]
    temps_smt=[]
    temps_auto=[]
    false_smt=[]
    false_auto=[]
    for filename in listfiles:
        #We only read files containing results for our benchmark.
        if tactic_name+"_" in filename : 
            file_res,temps_true_auto,temps_true_SMT,temps_false_auto,temps_false_SMT,temps_all_auto_res,temps_all_smt_res=read_file(filename,tactic,prover)
            res["SMT_"+prover+" false"]+=file_res["SMT_"+prover+" false"]
            res["SMT_"+prover+" true"]+=file_res["SMT_"+prover+" true"]
            res["SMT_"+prover+" fail"]+=file_res["SMT_"+prover+" fail"]
            res[tactic+" false"]+=file_res[tactic+" false"]
            res[tactic+" true"]+=file_res[tactic+" true"]
            res[tactic+" fail"]+=file_res[tactic+" fail"]
            res["SMT_"+prover+" true "+tactic+" false"]+=file_res["SMT_"+prover+" true "+tactic+" false"]
            res["SMT_"+prover+" false "+tactic+" true"]+=file_res["SMT_"+prover+" false "+tactic+" true"]
            temps_smt+=temps_true_SMT
            temps_auto+=temps_true_auto
            false_auto+=temps_false_auto
            false_smt+=temps_false_SMT
            temps_all_smt+=temps_all_smt_res
            temps_all_auto+=temps_all_auto_res
    table = [[res["SMT_"+prover+" true"],res["SMT_"+prover+" false"],res["SMT_"+prover+" fail"]],[res[tactic+" true"],res[tactic+" false"],res[tactic+" fail"]]]
    df=pd.DataFrame(table,columns=["true","false","fail"],index=["SMT_","tac"])
    print(df)
    print(f'Dont {res["SMT_"+prover+" true "+tactic+" false"]} cas où Smt est meilleur\nEt {res["SMT_"+prover+" false "+tactic+" true"]} cas où  est meilleur')

    print(f'Average time for true :')
    print(f'For auto: {sum(temps_auto)/len(temps_auto)}\n For smt: {sum(temps_smt)/len(temps_smt)}')

    print(f'Average time for false :')
    print(f'For auto: {sum(false_auto)/len(false_auto)}\n For smt: {sum(false_smt)/len(false_smt)}')


    colors = []
    markers=[]
    x,y=[],[]
    s=[1 for k in temps_all_smt]
    plt.rcParams.update({'font.size': 6})
    plt.rcParams["figure.figsize"] = (3.46,2.6)
    for k in range(len(temps_all_smt)):
        x.append(temps_all_auto[k][0])
        y.append(temps_all_smt[k][0])
        if temps_all_smt[k][0]/temps_all_auto[k][0]<1:
            if temps_all_smt[k][1]=="false":
                colors.append("darkgreen")
            else:
                colors.append("green")
        else:
            if temps_all_smt[k][1]=="false":
                colors.append("darkred")
                s[k]=2
            else:
                colors.append("red")
    plt.scatter(x,y,s, alpha=1,c=colors)
    axes=plt.gca()
    axes.set_yscale('log')
    axes.set_xscale('log')
    axes.set_xlim(10**(-4),100)
    axes.set_ylim(10**(-4),100)
    plt.plot([0,100],[0,100],color='red',alpha=0.3)
    axes.set_xlabel("Time auto (s)")
    axes.set_ylabel("Time smt CVC5 (s)")
    plt.tight_layout()
    plt.show()
    temps_all_smt=[temps_all_smt[k][0] for k in range(len(temps_all_smt))]
    print(f'Average time for all smt calls : {sum(temps_all_smt)/len(temps_all_smt)}')
   
if __name__=="__main__":
    os.chdir(sys.argv[1])
    main()



